"""
show_gps.py defines functions showing gps device info.
"""

from Tkinter import *
import thread
import time


class show_gps (Tk):
    """
    GUI class for gps devices.
    """

    def __init__(self, player, index=0, speed=10, master=None):
        """
	create a separate window using Tkinter widgets.
	create a thread for periodic sensory data update.
	"""
	# save the configuration
	self.__player = player
	self.__device_index = index
	self.__update_speed = speed
	# create a gui
	Tk.__init__(self)
	self.title('GPS : ' + str(self.__device_index))
	self.__x = Label(self)		# x
	self.__y = Label(self)		# y
	self.__heading = Label(self)	# heading
	# set layouts of widgets
	Label(self, text='X : ').grid(row=0, column=0, sticky=E)
	self.__x.grid(row=0, column=1, columnspan=5, sticky=W)
	Label(self, text='Y : ').grid(row=1, column=0, sticky=E)
	self.__y.grid(row=1, column=1, columnspan=5, sticky=W)
	Label(self, text='Heading : ').grid(row=2, column=0, sticky=E)
	self.__heading.grid(row=2, column=1, columnspan=5, sticky=W)
	self.grid()
	# start an update thread
	self.__update_flag = 1
	thread.start_new_thread(self.__update_thread, ())


    def configure(self, index=0, speed=10):
        """
	change the configuration on the fly.
	"""
	self.__device_index = index
	self.__update_speed = speed


    def close(self):
        """
	close the window, and kill it self.
	"""
	self.__update_flag = 0


    def __update_thread(self):
        """
	update sensory information.
	"""
	print '<start a gps update thread>'
	while self.__update_flag:
	    try:
		# update x info
		self.__x.configure(text='%10d' %
		    (self.__player.gps[self.__device_index][0]))
		# update y info
		self.__y.configure(text='%10d' %
		    self.__player.gps[self.__device_index][1])
		# update heading info
		self.__heading.configure(text='%10d' %
		    self.__player.gps[self.__device_index][2])
		# slow down
		time.sleep(1.0 / self.__update_speed)
	    except KeyError:
	        print '<gps:%d is not enabled yet>' % self.__device_index
		self.close()
	    except AttributeError:
		print '<invalid player object>'
	        self.close()
	    except TclError:
		self.close()
	print '<the gps update thread finishes>'

